<?php
/*
// "Content - Weblink Plugin" Plugin for Joomla 3.1 - Version 1.0.0
// License: GNU General Public License version 2 or later; see LICENSE.txt
// Author: Roland Verhaar ITWorks4All - roland.verhaar@itworks4all.com
// Copyright (C) 2016 Roland Verhaar - http://itworks4all.com. All rights reserved.
// 
// ***Last update: 2016-10-01***
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

//Include the weblink functions only once
// require_once __DIR__ . '/helper.php';

class plgContentWeblink extends JPlugin 
{

//#############################################################################

	//substitude keyword in article text with link to selected weblink

//#############################################################################

	public function onContentPrepare($context, &$article, &$params, $limitstart=0) 
	{
		// checking

		if (strpos($article->text, '{weblink') === false) 
		{
			return;
		}

		preg_match_all("/{weblink\s?(.*?)}(.*?){\/weblink}/", $article->text, $matches, PREG_SET_ORDER);

		// If no matches, skip this
		if ($matches)
		{
			foreach ($matches as $match)
			{
				$weblinklist = explode('|', $match[1]);
				// first get the defaults for target and follow
				$webtarget = $this->params->def('target', 'new');
				$webfollow = $this->params->def('follow', 'noindex, nofollow');
				$weblink = '';
				$webtext = '';
				
				if(trim($weblinklist[0]))
				{
					$weblink = trim($weblinklist[0]);
				}
				if(array_key_exists(2, $match))
				{
					$webtext = $match[2];
				}
				if(array_key_exists(1, $weblinklist))
				{
					$webtarget = trim($weblinklist[1]);
				}
				if(array_key_exists(2, $weblinklist))
				{
					switch (trim($weblinklist[2]))
					{
						case 'follow':
						$webfollow = 'index, follow';
						break;

						case 'nofollow':
						$webfollow = 'noindex, nofollow';
						break;
					}
				}

				$link = $this->_getLink($weblink);
				$weblinktext = $webtext;
								
				if($link)
				{
					$wlink = $link;
					if(array_key_exists(0, $link))
					{
						$wlink = $link[0];
					}
					switch ($webtarget)
					{
						case 'new':
							$weblinktext = '<a href="' . $wlink->link . '" target="_blank" rel="' . $webfollow . '">' .
								htmlspecialchars($webtext, ENT_COMPAT, 'UTF-8') . '</a>';
							break;
						case 'parent':
							$weblinktext = '<a href="' . $wlink->link . '" target="_self" rel="' . $webfollow . '">' .
								htmlspecialchars($webtext, ENT_COMPAT, 'UTF-8') . '</a>';
							break;
						case 'popup':
							$weblinktext = "<a href=\"#\" onclick=\"window.open('" . $wlink->link . "', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550'); return false\">" .
								htmlspecialchars($webtext, ENT_COMPAT, 'UTF-8') . "</a>";
							break;
					}
				}
				$article->text = str_replace($match[0], $weblinktext, $article->text );
			}
		}
	}
	protected function _getLink($weblink)
	{
		$count = $this->params->def('count', '1');

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$qcategory = $db->getQuery(true);
		$today = date('Y-m-d');
		
		$query->select($db->quoteName('a.url', 'url'));
		$query->select($db->quoteName('a.params', 'params'));
		$query->select($db->quoteName('a.state', 'state'));
		$query->select($db->quoteName('a.id', 'id'));
        	$query->from('#__weblinks AS a');
        	$query->where('a.state = 1 ' );
        	$query->where($db->quote($today) .' >= DATE_FORMAT(a.publish_up, "%Y-%m-%d") and ('.
        		$db->quote($today). ' <= DATE_FORMAT(a.publish_down, "%Y-%m-%d") or a.publish_down = "0000-00-00 00:00:00") ');
        	$query->where('( a.alias = '. $db->quote( strtolower( str_replace( ' ', '-', $weblink ))).
        		 ' OR a.title LIKE '. $db->quote( $weblink ).
        		 ' OR a.id = '. $db->quote((int) $weblink) .' )' );

		$qcategory->select($db->quoteName('a.url', 'url'));
		$qcategory->select($db->quoteName('a.params', 'params'));
		$qcategory->select($db->quoteName('a.state', 'state'));
		$qcategory->select($db->quoteName('a.id', 'id'));
        	$qcategory->from('#__weblinks AS a');
		$qcategory->join('RIGHT', $db->quoteName('#__categories', 'c') . ' ON (' . $db->quoteName('a.catid') . ' = ' . $db->quoteName('c.id') . ')');
        	$qcategory->where('a.state = 1' );
        	$qcategory->where($db->quote($today) .' >= DATE_FORMAT(a.publish_up, "%Y-%m-%d") and ('.
        		$db->quote($today). ' <= DATE_FORMAT(a.publish_down, "%Y-%m-%d") or a.publish_down = "0000-00-00 00:00:00") ');
        	$qcategory->where('( c.alias = '. $db->quote( strtolower( str_replace( ' ', '-', $weblink))). ' OR c.title LIKE '. $db->quote( $weblink ). ' )' );
        	$qcategory->order('RAND() LIMIT 1');

		$query->union($qcategory);

	        $db->setQuery($query);

	        $items = $db->loadObjectList();
	        
		if ($items)
		{
			foreach ($items as $item)
			{
				$params = json_decode( $item->params, true );

				if (is_array($params))
				{
					$countitem = $params['count_clicks'];
				}

				$item->link = $item->url;
				if ( ($countitem == '' && $count == '1') || $countitem == '1')
				{
					$item->link = JRoute::_('index.php?option=com_weblinks&task=weblink.go' . '&id=' . (int) $item->id );
				}

			}
			return $items;
		}
		return;
	}	
}	
		
